/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.2
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char ** config_arg;	/**< @brief configuration file to pass parameters.  */
  char ** config_orig;	/**< @brief configuration file to pass parameters original value given at command line.  */
  unsigned int config_min; /**< @brief configuration file to pass parameters's minimum occurreces */
  unsigned int config_max; /**< @brief configuration file to pass parameters's maximum occurreces */
  const char *config_help; /**< @brief configuration file to pass parameters help description.  */
  char * board_mac_arg;	/**< @brief MAC address of DAQ board.  */
  char * board_mac_orig;	/**< @brief MAC address of DAQ board original value given at command line.  */
  const char *board_mac_help; /**< @brief MAC address of DAQ board help description.  */
  char * daemon_mac_arg;	/**< @brief MAC address to use for talking to DAQ board.  */
  char * daemon_mac_orig;	/**< @brief MAC address to use for talking to DAQ board original value given at command line.  */
  const char *daemon_mac_help; /**< @brief MAC address to use for talking to DAQ board help description.  */
  int portA_mode_arg;	/**< @brief Mode of port A: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 (default='0').  */
  char * portA_mode_orig;	/**< @brief Mode of port A: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 original value given at command line.  */
  const char *portA_mode_help; /**< @brief Mode of port A: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 help description.  */
  int portB_mode_arg;	/**< @brief Mode of port B: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 (default='0').  */
  char * portB_mode_orig;	/**< @brief Mode of port B: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 original value given at command line.  */
  const char *portB_mode_help; /**< @brief Mode of port B: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 help description.  */
  int portC_mode_arg;	/**< @brief Mode of port C: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 (default='0').  */
  char * portC_mode_orig;	/**< @brief Mode of port C: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 original value given at command line.  */
  const char *portC_mode_help; /**< @brief Mode of port C: 0-disabled, 1-ADC, 2-DAC8734, 3-SENSE, 4-DAC1220 help description.  */
  int portA_nbits_arg;	/**< @brief Number of bits to receive in SPI mode (default='192').  */
  char * portA_nbits_orig;	/**< @brief Number of bits to receive in SPI mode original value given at command line.  */
  const char *portA_nbits_help; /**< @brief Number of bits to receive in SPI mode help description.  */
  int portB_nbits_arg;	/**< @brief Number of bits to receive in SPI mode (default='192').  */
  char * portB_nbits_orig;	/**< @brief Number of bits to receive in SPI mode original value given at command line.  */
  const char *portB_nbits_help; /**< @brief Number of bits to receive in SPI mode help description.  */
  int portC_nbits_arg;	/**< @brief Number of bits to receive in SPI mode (default='192').  */
  char * portC_nbits_orig;	/**< @brief Number of bits to receive in SPI mode original value given at command line.  */
  const char *portC_nbits_help; /**< @brief Number of bits to receive in SPI mode help description.  */
  int portA_enable_sampling_clock_arg;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling (default='0').  */
  char * portA_enable_sampling_clock_orig;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling original value given at command line.  */
  const char *portA_enable_sampling_clock_help; /**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling help description.  */
  int portB_enable_sampling_clock_arg;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling (default='0').  */
  char * portB_enable_sampling_clock_orig;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling original value given at command line.  */
  const char *portB_enable_sampling_clock_help; /**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling help description.  */
  int portC_enable_sampling_clock_arg;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling (default='0').  */
  char * portC_enable_sampling_clock_orig;	/**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling original value given at command line.  */
  const char *portC_enable_sampling_clock_help; /**< @brief Output sampling clock on pin 5 (CLKR) - WARNING ! Turn off board clock before enabling help description.  */
  int sync1_config_arg;	/**< @brief select source for sync1 signal (default='0').  */
  char * sync1_config_orig;	/**< @brief select source for sync1 signal original value given at command line.  */
  const char *sync1_config_help; /**< @brief select source for sync1 signal help description.  */
  int sync2_config_arg;	/**< @brief select source for sync2 signal (default='0').  */
  char * sync2_config_orig;	/**< @brief select source for sync2 signal original value given at command line.  */
  const char *sync2_config_help; /**< @brief select source for sync2 signal help description.  */
  int sync3_config_arg;	/**< @brief select source for sync3 signal (default='0').  */
  char * sync3_config_orig;	/**< @brief select source for sync3 signal original value given at command line.  */
  const char *sync3_config_help; /**< @brief select source for sync3 signal help description.  */
  int sync4_config_arg;	/**< @brief select source for sync4 signal (default='0').  */
  char * sync4_config_orig;	/**< @brief select source for sync4 signal original value given at command line.  */
  const char *sync4_config_help; /**< @brief select source for sync4 signal help description.  */
  int term1_pin0_arg;	/**< @brief select driver for term1 pin 0 - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * term1_pin0_orig;	/**< @brief select driver for term1 pin 0 - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *term1_pin0_help; /**< @brief select driver for term1 pin 0 - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int term1_pin1_arg;	/**< @brief select driver for term1 pin 1 - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * term1_pin1_orig;	/**< @brief select driver for term1 pin 1 - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *term1_pin1_help; /**< @brief select driver for term1 pin 1 - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int term1_pin2_arg;	/**< @brief select driver for term1 pin 2 - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * term1_pin2_orig;	/**< @brief select driver for term1 pin 2 - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *term1_pin2_help; /**< @brief select driver for term1 pin 2 - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int term1_pin3_arg;	/**< @brief select driver for term1 pin 3 - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * term1_pin3_orig;	/**< @brief select driver for term1 pin 3 - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *term1_pin3_help; /**< @brief select driver for term1 pin 3 - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int term1_pin4_arg;	/**< @brief select driver for term1 pin 4 - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * term1_pin4_orig;	/**< @brief select driver for term1 pin 4 - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *term1_pin4_help; /**< @brief select driver for term1 pin 4 - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int clkout_arg;	/**< @brief select driver for clkout pin - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * clkout_orig;	/**< @brief select driver for clkout pin - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *clkout_help; /**< @brief select driver for clkout pin - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int clkio_arg;	/**< @brief select driver for clkio pin - WARNING ! Read registers.h and analyze board schematic before enabling (default='0').  */
  char * clkio_orig;	/**< @brief select driver for clkio pin - WARNING ! Read registers.h and analyze board schematic before enabling original value given at command line.  */
  const char *clkio_help; /**< @brief select driver for clkio pin - WARNING ! Read registers.h and analyze board schematic before enabling help description.  */
  int sampling_clock_arg;	/**< @brief Source of main sampling clock: 0-disabled, 1-port A, 2-port B, 3-port C, 4-SMA, 5-25 Mhz, 6-TX, 7-RX (default='5').  */
  char * sampling_clock_orig;	/**< @brief Source of main sampling clock: 0-disabled, 1-port A, 2-port B, 3-port C, 4-SMA, 5-25 Mhz, 6-TX, 7-RX original value given at command line.  */
  const char *sampling_clock_help; /**< @brief Source of main sampling clock: 0-disabled, 1-port A, 2-port B, 3-port C, 4-SMA, 5-25 Mhz, 6-TX, 7-RX help description.  */
  int portA_xin_div_arg;	/**< @brief sampling clock divider for DAC1220 (default='7').  */
  char * portA_xin_div_orig;	/**< @brief sampling clock divider for DAC1220 original value given at command line.  */
  const char *portA_xin_div_help; /**< @brief sampling clock divider for DAC1220 help description.  */
  int portB_xin_div_arg;	/**< @brief sampling clock divider for DAC1220 (default='7').  */
  char * portB_xin_div_orig;	/**< @brief sampling clock divider for DAC1220 original value given at command line.  */
  const char *portB_xin_div_help; /**< @brief sampling clock divider for DAC1220 help description.  */
  int portC_xin_div_arg;	/**< @brief sampling clock divider for DAC1220 (default='7').  */
  char * portC_xin_div_orig;	/**< @brief sampling clock divider for DAC1220 original value given at command line.  */
  const char *portC_xin_div_help; /**< @brief sampling clock divider for DAC1220 help description.  */
  int sync1_divider_arg;	/**< @brief Divider of sync1 clock -1 (default='-1').  */
  char * sync1_divider_orig;	/**< @brief Divider of sync1 clock -1 original value given at command line.  */
  const char *sync1_divider_help; /**< @brief Divider of sync1 clock -1 help description.  */
  int sync1_phase_arg;	/**< @brief Starting phase of sync1 clock -1 (default='0').  */
  char * sync1_phase_orig;	/**< @brief Starting phase of sync1 clock -1 original value given at command line.  */
  const char *sync1_phase_help; /**< @brief Starting phase of sync1 clock -1 help description.  */
  int sync2_divider_arg;	/**< @brief Divider of sync1 clock -1 (default='-1').  */
  char * sync2_divider_orig;	/**< @brief Divider of sync1 clock -1 original value given at command line.  */
  const char *sync2_divider_help; /**< @brief Divider of sync1 clock -1 help description.  */
  int sync2_phase_arg;	/**< @brief Starting phase of sync1 clock -1 (default='0').  */
  char * sync2_phase_orig;	/**< @brief Starting phase of sync1 clock -1 original value given at command line.  */
  const char *sync2_phase_help; /**< @brief Starting phase of sync1 clock -1 help description.  */
  int sync3_divider_arg;	/**< @brief Divider of sync1 clock -1 (default='-1').  */
  char * sync3_divider_orig;	/**< @brief Divider of sync1 clock -1 original value given at command line.  */
  const char *sync3_divider_help; /**< @brief Divider of sync1 clock -1 help description.  */
  int sync3_phase_arg;	/**< @brief Starting phase of sync1 clock -1 (default='0').  */
  char * sync3_phase_orig;	/**< @brief Starting phase of sync1 clock -1 original value given at command line.  */
  const char *sync3_phase_help; /**< @brief Starting phase of sync1 clock -1 help description.  */
  int sync4_divider_arg;	/**< @brief Divider of sync1 clock -1 (default='-1').  */
  char * sync4_divider_orig;	/**< @brief Divider of sync1 clock -1 original value given at command line.  */
  const char *sync4_divider_help; /**< @brief Divider of sync1 clock -1 help description.  */
  int sync4_phase_arg;	/**< @brief Starting phase of sync1 clock -1 (default='0').  */
  char * sync4_phase_orig;	/**< @brief Starting phase of sync1 clock -1 original value given at command line.  */
  const char *sync4_phase_help; /**< @brief Starting phase of sync1 clock -1 help description.  */
  int nphases_arg;	/**< @brief Number of phases in differential data acquisition.  */
  char * nphases_orig;	/**< @brief Number of phases in differential data acquisition original value given at command line.  */
  const char *nphases_help; /**< @brief Number of phases in differential data acquisition help description.  */
  int reset_config_arg;	/**< @brief specify subsystems to reset upon startup (default='14').  */
  char * reset_config_orig;	/**< @brief specify subsystems to reset upon startup original value given at command line.  */
  const char *reset_config_help; /**< @brief specify subsystems to reset upon startup help description.  */
  int tiltmeter_mode_arg;	/**< @brief turn on tiltmeter specific code (default='0').  */
  char * tiltmeter_mode_orig;	/**< @brief turn on tiltmeter specific code original value given at command line.  */
  const char *tiltmeter_mode_help; /**< @brief turn on tiltmeter specific code help description.  */
  int jeep1_mode_arg;	/**< @brief turn on tiltmeter specific code (default='1').  */
  char * jeep1_mode_orig;	/**< @brief turn on tiltmeter specific code original value given at command line.  */
  const char *jeep1_mode_help; /**< @brief turn on tiltmeter specific code help description.  */
  int seism1_mode_arg;	/**< @brief turn on seismometer daq mode (default='0').  */
  char * seism1_mode_orig;	/**< @brief turn on seismometer daq mode original value given at command line.  */
  const char *seism1_mode_help; /**< @brief turn on seismometer daq mode help description.  */
  int jeep1_decimation_factor_arg;	/**< @brief downsample incoming data by averaging this many nearby samples (default='1000').  */
  char * jeep1_decimation_factor_orig;	/**< @brief downsample incoming data by averaging this many nearby samples original value given at command line.  */
  const char *jeep1_decimation_factor_help; /**< @brief downsample incoming data by averaging this many nearby samples help description.  */
  char * seism1_filename_prefix_arg;	/**< @brief base filename for seismometer daq output (default='seism').  */
  char * seism1_filename_prefix_orig;	/**< @brief base filename for seismometer daq output original value given at command line.  */
  const char *seism1_filename_prefix_help; /**< @brief base filename for seismometer daq output help description.  */
  double seism1_data_length_arg;	/**< @brief length of each data file in samples (default='2097152').  */
  char * seism1_data_length_orig;	/**< @brief length of each data file in samples original value given at command line.  */
  const char *seism1_data_length_help; /**< @brief length of each data file in samples help description.  */
  char * data_log_arg;	/**< @brief file to log incoming packets to.  */
  char * data_log_orig;	/**< @brief file to log incoming packets to original value given at command line.  */
  const char *data_log_help; /**< @brief file to log incoming packets to help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int config_given ;	/**< @brief Whether config was given.  */
  unsigned int board_mac_given ;	/**< @brief Whether board-mac was given.  */
  unsigned int daemon_mac_given ;	/**< @brief Whether daemon-mac was given.  */
  unsigned int portA_mode_given ;	/**< @brief Whether portA-mode was given.  */
  unsigned int portB_mode_given ;	/**< @brief Whether portB-mode was given.  */
  unsigned int portC_mode_given ;	/**< @brief Whether portC-mode was given.  */
  unsigned int portA_nbits_given ;	/**< @brief Whether portA-nbits was given.  */
  unsigned int portB_nbits_given ;	/**< @brief Whether portB-nbits was given.  */
  unsigned int portC_nbits_given ;	/**< @brief Whether portC-nbits was given.  */
  unsigned int portA_enable_sampling_clock_given ;	/**< @brief Whether portA-enable-sampling-clock was given.  */
  unsigned int portB_enable_sampling_clock_given ;	/**< @brief Whether portB-enable-sampling-clock was given.  */
  unsigned int portC_enable_sampling_clock_given ;	/**< @brief Whether portC-enable-sampling-clock was given.  */
  unsigned int sync1_config_given ;	/**< @brief Whether sync1-config was given.  */
  unsigned int sync2_config_given ;	/**< @brief Whether sync2-config was given.  */
  unsigned int sync3_config_given ;	/**< @brief Whether sync3-config was given.  */
  unsigned int sync4_config_given ;	/**< @brief Whether sync4-config was given.  */
  unsigned int term1_pin0_given ;	/**< @brief Whether term1-pin0 was given.  */
  unsigned int term1_pin1_given ;	/**< @brief Whether term1-pin1 was given.  */
  unsigned int term1_pin2_given ;	/**< @brief Whether term1-pin2 was given.  */
  unsigned int term1_pin3_given ;	/**< @brief Whether term1-pin3 was given.  */
  unsigned int term1_pin4_given ;	/**< @brief Whether term1-pin4 was given.  */
  unsigned int clkout_given ;	/**< @brief Whether clkout was given.  */
  unsigned int clkio_given ;	/**< @brief Whether clkio was given.  */
  unsigned int sampling_clock_given ;	/**< @brief Whether sampling-clock was given.  */
  unsigned int portA_xin_div_given ;	/**< @brief Whether portA-xin-div was given.  */
  unsigned int portB_xin_div_given ;	/**< @brief Whether portB-xin-div was given.  */
  unsigned int portC_xin_div_given ;	/**< @brief Whether portC-xin-div was given.  */
  unsigned int sync1_divider_given ;	/**< @brief Whether sync1-divider was given.  */
  unsigned int sync1_phase_given ;	/**< @brief Whether sync1-phase was given.  */
  unsigned int sync2_divider_given ;	/**< @brief Whether sync2-divider was given.  */
  unsigned int sync2_phase_given ;	/**< @brief Whether sync2-phase was given.  */
  unsigned int sync3_divider_given ;	/**< @brief Whether sync3-divider was given.  */
  unsigned int sync3_phase_given ;	/**< @brief Whether sync3-phase was given.  */
  unsigned int sync4_divider_given ;	/**< @brief Whether sync4-divider was given.  */
  unsigned int sync4_phase_given ;	/**< @brief Whether sync4-phase was given.  */
  unsigned int nphases_given ;	/**< @brief Whether nphases was given.  */
  unsigned int reset_config_given ;	/**< @brief Whether reset-config was given.  */
  unsigned int tiltmeter_mode_given ;	/**< @brief Whether tiltmeter-mode was given.  */
  unsigned int jeep1_mode_given ;	/**< @brief Whether jeep1-mode was given.  */
  unsigned int seism1_mode_given ;	/**< @brief Whether seism1-mode was given.  */
  unsigned int jeep1_decimation_factor_given ;	/**< @brief Whether jeep1-decimation-factor was given.  */
  unsigned int seism1_filename_prefix_given ;	/**< @brief Whether seism1-filename-prefix was given.  */
  unsigned int seism1_data_length_given ;	/**< @brief Whether seism1-data-length was given.  */
  unsigned int data_log_given ;	/**< @brief Whether data-log was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_config_file() instead
 */
int cmdline_parser_configfile (const char *filename,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_config_file (const char *filename,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * The string parser (interprets the passed string as a command line)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_string (const char *cmdline, struct gengetopt_args_info *args_info,
  const char *prog_name);
/**
 * The string parser (version with additional parameters - deprecated)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_string_ext() instead
 */
int cmdline_parser_string2 (const char *cmdline, struct gengetopt_args_info *args_info,
  const char *prog_name,
  int override, int initialize, int check_required);
/**
 * The string parser (version with additional parameters)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_string_ext (const char *cmdline, struct gengetopt_args_info *args_info,
  const char *prog_name,
  struct cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
