#ifndef __CONTROL_INTERFACE_H__
#define __CONTROL_INTERFACE_H__

void init_cc(void);
void accept_connection(void);
int max_cc_fd(void);
void set_cc_fds(fd_set *fd_read, fd_set *fd_write);
void write_cc_data(fd_set *fd_write);
void read_cc_data(fd_set *fd_read);
void parse_control_cmd(char *str, int count);
void broadcast(const char *fmt, ...);

typedef struct {
	char *name;
	char *format;
	char *scan_format;
	int type;
	void *var;
	void *priv;
	void (*callback)(void *);
	} VARIABLE;	

#define TYPE_DOUBLE  1
#define TYPE_INT     2

#define DECLARE_VAR(var, type) {\
	#var, (type==TYPE_INT ? "%d" : (type==TYPE_DOUBLE ? "%.12lg" : "UNKNOWN_TYPE")), (type==TYPE_INT ? "%d" : (type==TYPE_DOUBLE ? "%lg" : "UNKNOWN_TYPE")), type, &var, NULL, NULL \
	}

#define END_VARS {NULL, NULL, NULL, 0, NULL, NULL, NULL}

void add_variables(VARIABLE *v, int count);
void broadcast_variables(VARIABLE *v, int count);
void broadcast_all_variables(void);
void set_variable(char *s);


#endif
