#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>

#include "daemon.h"
#include "control_interface.h"
#include "send_cmd.h"
#include "tiltmeter.h"
#include "cmdline.h"


extern struct gengetopt_args_info args_info;



static double adc_accum[24]={0, 0, 0, 0, 0, 0, 0, 0};
static double adc_accum_max[24]={0, 0, 0, 0, 0, 0, 0, 0};
static double adc_accum_min[24]={0, 0, 0, 0, 0, 0, 0, 0};
static int phase_count[48]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
static int accum_count[3]={0, 0, 0};


void jeep1_process_adc_packet(int channel, int phases, double sample_count, double *adc, int nadc)
{
int i;
int count_offset=channel-1;
int adc_offset=count_offset*8;
int phase_offset=count_offset*16;
struct timeval tv;

if(channel<1  || channel > 3) {
	fprintf(stderr, "***INTERNAL ERROR: channel=%d\n", channel);
	return;
	}

if(accum_count[count_offset]==0) {
	for(i=0;i<nadc;i++) {
		adc_accum_max[adc_offset+i]=adc[i];
		adc_accum_min[adc_offset+i]=adc[i];
		}
	} else {
	for(i=0;i<nadc;i++) {
		if(adc_accum_max[adc_offset+i]<adc[i])adc_accum_max[adc_offset+i]=adc[i];
		if(adc_accum_min[adc_offset+i]>adc[i])adc_accum_min[adc_offset+i]=adc[i];
		}
	}

phase_count[phase_offset+phases]++;
for(i=0;i<nadc;i++)adc_accum[adc_offset+i]+=adc[i];
accum_count[count_offset]++;

{
static int t=0;

//set_dac4x(2, 2.0+0.1*sin(t/300), 2.0+0.1*sin(t/300), 2.0+0.1*sin(t/300), 2.0+0.1*sin(t/300));
t++;
}

if(accum_count[count_offset]==args_info.jeep1_decimation_factor_arg) {
	gettimeofday(&tv, NULL);
	broadcast("JEEP1 %.8f %.0f MEAN %.8f %.8f %.8f %.8f %.8f %.8f %.8f %.8f MAX %.8f %.8f %.8f %.8f %.8f %.8f %.8f %.8f MIN %.8f %.8f %.8f %.8f %.8f %.8f %.8f %.8f PHASE_COUNT %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n", (1.0*tv.tv_sec+1e-6*tv.tv_usec), sample_count, 
		  adc_accum[adc_offset+0]/accum_count[count_offset],
		  adc_accum[adc_offset+1]/accum_count[count_offset],
		  adc_accum[adc_offset+2]/accum_count[count_offset],
		  adc_accum[adc_offset+3]/accum_count[count_offset],
		  adc_accum[adc_offset+4]/accum_count[count_offset],
		  adc_accum[adc_offset+5]/accum_count[count_offset],
		  adc_accum[adc_offset+6]/accum_count[count_offset],
		  adc_accum[adc_offset+7]/accum_count[count_offset],

  		  adc_accum_max[adc_offset+0],
  		  adc_accum_max[adc_offset+1],
  		  adc_accum_max[adc_offset+2],
  		  adc_accum_max[adc_offset+3],
  		  adc_accum_max[adc_offset+4],
  		  adc_accum_max[adc_offset+5],
  		  adc_accum_max[adc_offset+6],
  		  adc_accum_max[adc_offset+7],

  		  adc_accum_min[adc_offset+0],
  		  adc_accum_min[adc_offset+1],
  		  adc_accum_min[adc_offset+2],
  		  adc_accum_min[adc_offset+3],
  		  adc_accum_min[adc_offset+4],
  		  adc_accum_min[adc_offset+5],
  		  adc_accum_min[adc_offset+6],
  		  adc_accum_min[adc_offset+7],

		  phase_count[phase_offset+0],
		  phase_count[phase_offset+1],
		  phase_count[phase_offset+2],
		  phase_count[phase_offset+3],
		  phase_count[phase_offset+4],
		  phase_count[phase_offset+5],
		  phase_count[phase_offset+6],
		  phase_count[phase_offset+7],
		  phase_count[phase_offset+8],
		  phase_count[phase_offset+9],
		  phase_count[phase_offset+10],
		  phase_count[phase_offset+11],
		  phase_count[phase_offset+12],
		  phase_count[phase_offset+13],
		  phase_count[phase_offset+14],
		  phase_count[phase_offset+15]
		  );
	for(i=0;i<8;i++)adc_accum[adc_offset+i]=0;
	for(i=0;i<16;i++)phase_count[phase_offset+i]=0;
	accum_count[count_offset]=0;
	}
}
