#ifndef __REGISTERS_H__
#define __REGISTERS_H__

#define REG_NOP				0

#define REG_GENERAL_CONFIG		1
#define REG_GENERAL_CONFIG_REQUEST_STATUS	1

#define REG_PORT_CONFIG			2

#define REG_PORT_CONFIG_SHIFT_PORTA	0
#define REG_PORT_CONFIG_SHIFT_PORTB	8
#define REG_PORT_CONFIG_SHIFT_PORTC	16
#define REG_PORT_CONFIG_PORT_DISABLED	0
#define REG_PORT_CONFIG_PORT_ADS1274	1
#define REG_PORT_CONFIG_PORT_DAC8734	2
#define REG_PORT_CONFIG_PORT_SENSE	3
#define REG_PORT_CONFIG_PORT_DAC1220	4

#define REG_PORT_CONFIG_SHIFT_PORTA_SAMPLING_CLK_ENABLE	32
#define REG_PORT_CONFIG_SHIFT_PORTB_SAMPLING_CLK_ENABLE	33
#define REG_PORT_CONFIG_SHIFT_PORTC_SAMPLING_CLK_ENABLE	34

#define REG_PORT_CONFIG_SHIFT_PORTA_NBITS	40
#define REG_PORT_CONFIG_SHIFT_PORTB_NBITS	48
#define REG_PORT_CONFIG_SHIFT_PORTC_NBITS	56


#define REG_CLOCK_CONFIG		3

#define REG_CLOCK_CONFIG_SAMPLING_CLK_DISABLED	0
#define REG_CLOCK_CONFIG_SAMPLING_CLK_PORTA	1
#define REG_CLOCK_CONFIG_SAMPLING_CLK_PORTB	2
#define REG_CLOCK_CONFIG_SAMPLING_CLK_PORTC	3
#define REG_CLOCK_CONFIG_SAMPLING_CLK_SMA	4
#define REG_CLOCK_CONFIG_SAMPLING_CLK_25MHZ	5
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TX_CLK	6
#define REG_CLOCK_CONFIG_SAMPLING_CLK_RX_CLK	7
#define REG_CLOCK_CONFIG_SAMPLING_CLK_CLKOUT	8
#define REG_CLOCK_CONFIG_SAMPLING_CLK_CLKIO	9
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM1_0	10
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM1_1	11
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM1_2	12
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM1_3	13
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM2_0	14
#define REG_CLOCK_CONFIG_SAMPLING_CLK_TERM2_1	15



#define REG_CLOCK_CONFIG_TERM1_MUX_HIGHZ_OFF	0
#define REG_CLOCK_CONFIG_TERM1_MUX_SLOW_CLK0	1
#define REG_CLOCK_CONFIG_TERM1_MUX_SLOW_CLK1	2
#define REG_CLOCK_CONFIG_TERM1_MUX_SLOW_CLK2	3
#define REG_CLOCK_CONFIG_TERM1_MUX_SLOW_CLK3	4
#define REG_CLOCK_CONFIG_TERM1_MUX_SYNC_FLAG0	5
#define REG_CLOCK_CONFIG_TERM1_MUX_SYNC_FLAG1	6
#define REG_CLOCK_CONFIG_TERM1_MUX_SYNC_FLAG2	7
#define REG_CLOCK_CONFIG_TERM1_MUX_SYNC_FLAG3	8
#define REG_CLOCK_CONFIG_TERM1_MUX_SAMPLING_CLK	9
#define REG_CLOCK_CONFIG_TERM1_MUX_SCLK		10
#define REG_CLOCK_CONFIG_TERM1_MUX_25MHZ	11
#define REG_CLOCK_CONFIG_TERM1_MUX_50MHZ	12
#define REG_CLOCK_CONFIG_TERM1_MUX_SMA_CLK	13
#define REG_CLOCK_CONFIG_TERM1_MUX_LOW		14
#define REG_CLOCK_CONFIG_TERM1_MUX_HIGH		15

#define REG_CLOCK_CONFIG_TERM1_SHIFT_PIN0	4
#define REG_CLOCK_CONFIG_TERM1_SHIFT_PIN1	8
#define REG_CLOCK_CONFIG_TERM1_SHIFT_PIN2	12
#define REG_CLOCK_CONFIG_TERM1_SHIFT_PIN3	16
#define REG_CLOCK_CONFIG_TERM1_SHIFT_PIN4	20
#define REG_CLOCK_CONFIG_TERM1_SHIFT_CLKOUT	24
#define REG_CLOCK_CONFIG_TERM1_SHIFT_CLKIO	28


#define REG_SLOW_CLK1_CONFIG		4
#define REG_SLOW_CLK2_CONFIG		5
#define REG_SLOW_CLK3_CONFIG		6
#define REG_SLOW_CLK4_CONFIG		7

#define REG_SLOW_CLK_CONFIG_SHIFT_PHASE 0
#define REG_SLOW_CLK_CONFIG_SHIFT_DIV   16
#define REG_SLOW_CLK_CONFIG_START       (1L<<63)
#define REG_SLOW_CLK_CONFIG_STOP	(1L<<62)

#define REG_SYNC1_CONFIG		8
#define REG_SYNC2_CONFIG		9
#define REG_SYNC3_CONFIG		10
#define REG_SYNC4_CONFIG		11

#define REG_SYNC_CONFIG_ZERO		0
#define REG_SYNC_CONFIG_A_READY		1
#define REG_SYNC_CONFIG_B_READY		2
#define REG_SYNC_CONFIG_C_READY		3
#define REG_SYNC_CONFIG_TERM1_0		4
#define REG_SYNC_CONFIG_TERM1_1		5
#define REG_SYNC_CONFIG_TERM1_2		6
#define REG_SYNC_CONFIG_TERM1_3		7
#define REG_SYNC_CONFIG_TERM1_4		8
#define REG_SYNC_CONFIG_SLOW_CLK1	9
#define REG_SYNC_CONFIG_SLOW_CLK2	10
#define REG_SYNC_CONFIG_SLOW_CLK3	11
#define REG_SYNC_CONFIG_SLOW_CLK4	12
#define REG_SYNC_CONFIG_TERM2_0		13
#define REG_SYNC_CONFIG_TERM2_1		14
#define REG_SYNC_CONFIG_TERM2_2		15
#define REG_SYNC_CONFIG_TERM2_3		16
#define REG_SYNC_CONFIG_TERM2_4		17
#define REG_SYNC_CONFIG_CLKIO		18
#define REG_SYNC_CONFIG_CLKOUT		19
#define REG_SYNC_CONFIG_ONE		20

#define REG_A_XIN_DIV			12
#define REG_B_XIN_DIV			13
#define REG_C_XIN_DIV			14

#define REG_DESTINATION_MAC		0x100
#define REG_SOURCE_MAC			0x101

#define REG_RESET_CONFIG		0x557
#define REG_RESET_CONFIG_GLOBAL_RESET	(1<<0)
#define REG_RESET_CONFIG_PORTA_RESET	(1<<1)
#define REG_RESET_CONFIG_PORTB_RESET	(1<<2)
#define REG_RESET_CONFIG_PORTC_RESET	(1<<3)
#define REG_RESET_CONFIG_ACQUISITION_FIFO_RESET	(1<<4)

#define REG_LEDS				0x1000


#define CMD_WRITE_RX_REG		1
#define CMD_READ_RX_REG			2 /* not implemented */
#define CMD_WRITE_COMMAND		3

#endif