#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>

#include "daemon.h"
#include "control_interface.h"
#include "send_cmd.h"
#include "tiltmeter.h"
#include "cmdline.h"

extern struct gengetopt_args_info args_info;

static FILE *seism1_output=NULL;
static double seism1_output_start=0;
static char s[20000];

void seism1_process_adc_packet(int channel, int phases, double sample_count, double *adc, int nadc)
{
int i;
if( (seism1_output==NULL) || (sample_count-seism1_output_start >= args_info.seism1_data_length_arg) || (sample_count<seism1_output_start)) {
	if(seism1_output!=NULL)fclose(seism1_output);
	snprintf(s, 20000, "%s-%.0f.log", args_info.seism1_filename_prefix_arg, sample_count);
	seism1_output=fopen(s, "w");
	if(seism1_output==NULL) {
		perror(s);
		return;
		}
	seism1_output_start=sample_count;
	}
fprintf(seism1_output, "SEISM1 %d %d %.0f", channel, phases, sample_count);
for(i=0;i<nadc;i++)fprintf(seism1_output, " %.8f", adc[i]);
fprintf(seism1_output, "\n");
}
