#ifndef __TILTMETER_H__
#define __TILTMETER_H__

void init_tiltmeter(void);

void send_header(void);

void tiltmeter_process_adc_packet(int channel, int phases, double sample_count, double *adc, int nadc);

void set_working_point (double a);

void set_kick_constant (double a);

void set_damping_constant (double a);
void set_damping_highpass(double a);
void set_damping_amplitude(double a);

void set_gain (double a);

void set_antispring (double a);

void update_position (double sample_count, double ch0, double ch1, double ch2, double ch3);

void integrator (double sample_count, double ch0, double ch1, double ch2, double ch3);

void broadcast_tiltmeter_vars(void);

#endif
